
/*****************************************************************************************************************
(C) Copyright 2004 - Analog Devices, Inc.  All rights reserved.

File Name:		Overlay_Manager.asm

Date Created:	09/04 Rev. 1.0		Aseem V / Ramesh Babu

PURPOSE:	The file contains overlay manager code.
					

************************************************************************************************/


#include "def2181.h"


.SECTION/DM       data1;

/*  The following constants are defined by the linker.  */
/*  These constants contain the word size, live locaton */
/*  and run location of the overlay functions.	        */

.EXTERN _ov_word_size_run_1;
.EXTERN _ov_word_size_run_2;
.EXTERN _ov_word_size_live_1;
.EXTERN _ov_word_size_live_2;
.EXTERN _ov_startaddress_1;
.EXTERN _ov_startaddress_2;
.EXTERN _ov_runtimestartaddress_1;
.EXTERN _ov_runtimestartaddress_2;

/*  Placing the linker constants in an array so the overlay  */
/*  manager can use the appropriate constant based on the    */
/*  overlay id.						     */

.VAR  liveAddresses[2] = _ov_startaddress_1, _ov_startaddress_2;
.VAR  runAddresses[2]  = _ov_runtimestartaddress_1, _ov_runtimestartaddress_2;
.VAR  runWordSize[2] = _ov_word_size_run_1,_ov_word_size_run_2;
.VAR  liveWordSize[2] = _ov_word_size_live_1,_ov_word_size_live_2;


.var save_restore_stack[20];


.section/pm program;
.global Overlay_Manager;
Overlay_Manager:

//Please save the registers used in Overlay Manager here__________________	
	dm(save_restore_stack) = AR;
	dm(save_restore_stack+1) = M0;
	dm(save_restore_stack+2) = M3;
	dm(save_restore_stack+3) = I0;
	dm(save_restore_stack+4) = I2;
	dm(save_restore_stack+5) = I3;
	dm(save_restore_stack+6) = AX0;
	
//________________________________________________________________________

	AR = AY0 -1;  //Get Pointer
	
	M0 = AR;  // Save the pointer in Modifier Regs.
	M3 = 0;
	I0 = liveAddresses;
	I2 = runAddresses;
	I3 = runWordSize;
	
	modify(I0,M0);
	modify(I2,M0);
	modify(I3,M0);
		//Load the BDMA registers and trigger the Byte DMA transfer
		AX0=DM(I0,M0);
		dm(BDMA_External_Address)=AX0;
		
		AX0=DM(I2,M3);
		dm(BDMA_Internal_Address)=AX0;
		
		AX0=0x000;
		dm(BDMA_Control)=AX0;
		
		AX0 = DM(I3,M0);
		dm(BDMA_Word_Count)=AX0;
		//____________________________________________________________
		//Wait for BDMA interrupt
		idle;
		//____________________________________________________________
		AX0 = DM(I2,M3);
		
		I6 = AX0;
//Please restore the registers used in Overlay Manager here__________________
	AR = dm(save_restore_stack);
	M0 = dm(save_restore_stack+1);
	M3 = dm(save_restore_stack+2);
	I0 = dm(save_restore_stack+3);
	I2 = dm(save_restore_stack+4);
	I3 = dm(save_restore_stack+5);
	AX0 = dm(save_restore_stack+6);
//________________________________________________________________________
	
	jump(i6);//Jump to runtime address and execute from there

		

Overlay_Manager.END:

//BDMA ISR_____________________________________________________________

BDMA_interrupt:
.global	BDMA_interrupt;

	nop;
	nop;
	rti;
BDMA_interrupt.END:
//______________________________________________________________________
